--THIS IS VERY CLEVER THANK YOU BUSHY
--WE ROUTE ALL FILES THROUGH CORE HERE.  BE SURE TO DEFINE FILES AND/OR CODE HERE
if not _G.GWCBase then
	_G.GWCBase = {}
	GWCBase.mod_path = ModPath
	GWCBase._data_path = SavePath .. "GWCBase.txt"
	--GWCBase._data = {}
	GWCBase.options = {}
	GWCBase.main_menu = "GWCBase_menu"
end



--GWCBase.MenuFile = "weapon_visual_customization.txt"
GWCBase._update_queue = {}
GWCBase._melee_save_path = SavePath .. "goonmod_weapon_customization_melee.txt"

GWCBase._default_part_visual_blueprint =  {
	["materials"] = "no_material",
	["textures"] = "no_color_no_material",
	["colors"] = "white_solid",
}

GWCBase._mod_overrides_download_location = "https://github.com/JamesWilko/GoonMod/archive/WeaponCustomizerModOverrides.zip"
GWCBase._customizer_skin_id = "goonmod_custom_skin"
local CUSTOMIZER_SKIN_ID = GWCBase._customizer_skin_id

-- Options
if GWCBase.Options == nil then
	GWCBase.Options = {}
	GWCBase.Options.Color1R = 1
	GWCBase.Options.Color1G = 1
	GWCBase.Options.Color1B = 1
	GWCBase.Options.Color2R = 1
	GWCBase.Options.Color2G = 1
	GWCBase.Options.Color2B = 1
	GWCBase.Options.Pattern = 1
	GWCBase.Options.Material = 1
	GWCBase.Options.HideDiffuse = false
	GWCBase.Options.HideNormal = false
	GWCBase.Options.TempShownOverridesNotInstalled = false
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_GWCBase", function( loc )
	loc:load_localization_file( GWCBase.mod_path .. "Loc/en.txt")
end)

--[[
	Setup our menu callbacks, load our saved data, and build the menu from our json file.
]]
Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_GWCBase", function( menu_manager )

	--[[
		Setup our callbacks as defined in our item callback keys, and perform our logic on the data retrieved.
	]]

	-- Callbacks
	MenuCallbackHandler.WeaponCustomizationClearDataAll = function(this, item)
		GWCBase:ClearDataFromSave()
	end

	MenuCallbackHandler.WeaponCustomizationClearDataPrimaries = function(this, item)
		GWCBase:EraseSaveDataPrimary()
	end

	MenuCallbackHandler.WeaponCustomizationClearDataSecondaries = function(this, item)
		GWCBase:EraseSaveDataSecondary()
	end

	MenuCallbackHandler.WeaponCustomizationClearDataMelee = function(this, item)
		GWCBase:EraseSaveDataMelee()
	end

	--[[
		Load our previously saved data from our save file.
	]]
	

	--[[
		Load our menu json file and pass it to our MenuHelper so that it can build our in-game menu for us.
		We pass our parent mod table as the second argument so that any keybind functions can be found and called
			as necessary.
		We also pass our data table as the third argument so that our saved values can be loaded from it.
	]]
	MenuHelper:LoadFromJsonFile( GWCBase.mod_path .. "menus/weapon_visual_customization.txt", GWCBase, GWCBase.options )
end )

function GWCBase:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self.options ) )
		file:close()
	end
end

function GWCBase:Load()
	local file = io.open( self._data_path, "r" )
	--if file == nil then
	--	log("[GWCBase] No settings file found, initiating first launch...")
	--	GWCBase:FirstLaunch()
	--	return
	--end
	if file then
		self.options = json.decode( file:read("*all") )
		file:close()
	end
end


--[[function GWCBase:FirstLaunch()
	local option = GWCBase.options
	if GWCBase.options.GWCBase_hud_global == nil then
		GWCBase.options.GWCBase_hud_global = true
	end
	option.GWCBase_assault_global = true
	GWCBase:Save()
end]]

GWCBase.dofiles = {
	"weapon_customization_menus.lua",
	"weapon_customization_part_data.lua"
}

--Our hook files.  Make sure all hooks in the mod.txt link to this Core.lua.
--If a feature isn't working, just comment it out before pushing a version.  Include a comment of what's broken, if possible.
GWCBase.hook_files = {

	["lib/units/beings/player/states/playerstandard"] = "lua/PlayerStandard.lua",
	["lib/managers/menu/blackmarketgui"] = "lua/BlackMarketGUI.lua",
	["lib/managers/blackmarketmanager"] = "lua/BlackMarketManager.lua",
	["lib/units/weapons/newraycastweaponbase"] = "lua/NewRaycastWeaponBase.lua",
	["lib/units/cameras/fpcameraplayerbase"] = "lua/FPCameraPlayerBase.lua",
	["lib/managers/menu/menuscenemanager"] = "lua/MenuSceneManager.lua",
	["lib/units/beings/player/playerinventory"] = "lua/PlayerInventory.lua",
	["lib/managers/menu/playerprofileguiobject"] = "lua/PlayerProfileGUIObject.lua",
	["lib/managers/menu/playerinventorygui"] = "lua/PlayerInventoryGUI.lua",
	["lib/tweak_data/blackmarket/weaponskinstweakdata"] = "lua/WeaponSkinsTweakData.lua"
}

if not GWCBase.setup then

	GWCBase:Load()
	for p, d in pairs(GWCBase.dofiles) do
		dofile(ModPath .. d)
	end
	GWCBase.setup = true
	log("[GWCBase] Loaded options")
end



if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if GWCBase.hook_files[requiredScript] then
		dofile( ModPath .. GWCBase.hook_files[requiredScript] )
	end
end

-- Hooks
Hooks:Add("BlackMarketTweakDataPostInitWeaponSkins", "BlackMarketTweakDataPostInitWeaponSkins.GWCBase", function( tweak )

	tweak.weapon_skins[CUSTOMIZER_SKIN_ID] = {}
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].name_id = "bm_wskn_goonmod_custom_skin"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].unique_name_id = "bm_wskn_goonmod_custom_skin"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].desc_id = "bm_wskn_goonmod_custom_skin_desc"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].weapon_id = "deagle"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].rarity = "epic"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].bonus = "recoil_p2"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].reserve_quality = false
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].texture_bundle_folder = "cash/safes/cf15"
	tweak.weapon_skins[CUSTOMIZER_SKIN_ID].locked = false

end)

Hooks:Add("BlackMarketManagerPreGetInventoryTradable", "BlackMarketManagerPreGetInventoryTradable.GWCBase", function(blackmarket)

	-- Only add the custom tradable if we're not calling this from the Steam inventory,
	-- that way we only display the custom skin button in the weapon inventory
	local call_func = debug.getinfo(4).name
	if call_func == "populate_inventory_tradable" and blackmarket._global.inventory_tradable then

		blackmarket._global.inventory_tradable[CUSTOMIZER_SKIN_ID] = nil

	elseif blackmarket._global.inventory_tradable and not blackmarket._global.inventory_tradable[CUSTOMIZER_SKIN_ID] then

		local data = {}
		data["category"] = "weapon_skins"
		data["entry"] = CUSTOMIZER_SKIN_ID
		data["bonus"] = false
		data["amount"] = 1
		data["quality"] = "mint"
		blackmarket._global.inventory_tradable[CUSTOMIZER_SKIN_ID] = data

	end

end)

Hooks:Add("BlackMarketManagerModifyGetCosmeticsInstancesByWeaponId", "BlackMarketManagerModifyGetCosmeticsInstancesByWeaponId.GWCBase", function(blackmarket, weapon_id, items)
	table.insert(items, CUSTOMIZER_SKIN_ID)
end)

Hooks:Add("BlackMarketGUIModifyWeaponCosmeticsActionList", "BlackMarketGUIModifyWeaponCosmeticsActionList.GWCBase", function(gui, data, new_data)

	if new_data.name == CUSTOMIZER_SKIN_ID then

		-- Clear actions list
		for k, v in ipairs(new_data) do
			new_data[k] = nil
		end

		-- Custom actions
		local crafted = managers.blackmarket:get_crafted_category(data.category)[data.prev_node_data and data.prev_node_data.slot]
		if crafted and crafted.cosmetics then
			table.insert( new_data, "wcc_goonmod_apply" )
		else
			table.insert( new_data, "wcc_goonmod_edit" )
		end

	end

end)

Hooks:Add("BlackMarketGUIPostSetup", "BlackMarketGUIPostSetup.GWCBase", function(gui, is_start_page, component_data)

	-- Create open editor button
	local btn_x = 10
	if gui._btns then

		local BTNS = {
			wcc_goonmod_edit = {
				prio = 1,
				btn = "BTN_A",
				pc_btn = nil,
				name = "bm_menu_btn_edit_goonmod_cosmetic",
				callback = callback(GWCBase, GWCBase, "weapon_visual_customization_callback")
			},
			wcc_goonmod_apply = {
				prio = 1,
				btn = "BTN_A",
				pc_btn = nil,
				name = "bm_menu_btn_choose_goonmod_cosmetic",
				callback = nil
			}
		}

		local btn_x = 10
		for btn, btn_data in pairs(BTNS) do
			local new_btn = BlackMarketGuiButtonItem:new(gui._buttons, btn_data, btn_x)
			gui._btns[btn] = new_btn
		end

	end

end)

Hooks:Add("MenuManagerOnBack", "MenuManagerOnBack.GWCBase", function(menu, queue, skip_nodes)
	
	if GWCBase._is_previewing then
		local gui = managers.menu_component._blackmarket_gui
		if gui then
			local data = GWCBase._is_previewing.data
			managers.blackmarket:view_weapon(data.category, data.slot, callback(gui, gui, "_update_crafting_node"), nil, BlackMarketGui.get_crafting_custom_data())
		end
	end

end)

Hooks:Add("BlackMarketGUIOnPreviewWeapon", "BlackMarketGUIOnPreviewWeapon.GWCBase", function(gui, data)
	GWCBase._is_previewing = {
		["previewing"] = true,
		["data"] = data,
	}
end)

Hooks:Add("BlackMarketGUIOnStartCraftingWeapon", "BlackMarketGUIOnStartCraftingWeapon.GWCBase", function(gui, data, new_node_data)
	GWCBase._is_previewing = {
		["previewing"] = true,
		["data"] = data,
	}
end)

Hooks:Add("MenuSceneManagerSpawnedItemWeapon", "MenuSceneManagerSpawnedItemWeapon.", function(menu, factory_id, blueprint, cosmetics, texture_switches, custom_data, spawned_unit)

	GWCBase._menu_weapon_preview_unit = spawned_unit

	if GWCBase._is_previewing then
		local data = GWCBase._is_previewing["data"]
		GWCBase:LoadCurrentWeaponCustomization( data )
	end

end)

Hooks:Add("MenuSceneManagerSpawnedMeleeWeapon", "MenuSceneManagerSpawnedMeleeWeapon.", function(menu, melee_weapon_id, spawned_unit)

	GWCBase._menu_weapon_preview_unit = spawned_unit
	GWCBase:LoadCurrentWeaponCustomization({
		name = melee_weapon_id,
		category = "melee_weapons",
		slot = 0
	})

	if managers.blackmarket._customizing_weapon_data then
		GWCBase:_open_weapon_customization_preview_node()
	end

end)

Hooks:Add("NewRaycastWeaponBasePostAssemblyComplete", "NewRaycastWeaponBasePostAssemblyComplete.GWCBase", function(weapon, clbk, parts, blueprint)
	GWCBase:LoadEquippedWeaponCustomizations( weapon )
end)

Hooks:Add("PlayerStandardStartActionEquipWeapon", "PlayerStandardStartActionEquipWeapon.GWCBase", function(ply, t)
	if managers.player:local_player() then
		GWCBase:LoadEquippedWeaponCustomizations( managers.player:local_player():inventory():equipped_unit():base() )
	end
end)

Hooks:Add("PlayerStandardStartMaskUp", "PlayerStandardStartMaskUp.GWCBase", function(ply, data)
	if managers.player:local_player() then
		GWCBase:LoadEquippedWeaponCustomizations( managers.player:local_player():inventory():equipped_unit():base() )
	end
end)

Hooks:Add("FPCameraPlayerBaseOnSpawnMeleeItem", "FPCameraPlayerBaseOnSpawnMeleeItem.GWCBase", function(camera, melee_units)

	if melee_units then
		for k, v in pairs( melee_units ) do
			GWCBase:LoadEquippedWeaponCustomizations( v, true )
		end
	end

end)

Hooks:Add("BlackMarketGUIOnPopulateMaskMods", "BlackMarketGUIOnPopulateMaskMods.GWCBase", function(gui, data)

	-- Create "no material" data
	if not tweak_data.blackmarket.materials.no_material then

		tweak_data.blackmarket.materials.no_material = {}
		tweak_data.blackmarket.materials.no_material.name_id = "bm_mtl_no_material"
		tweak_data.blackmarket.materials.no_material.texture = "units/payday2/matcaps/matcap_plastic_df"
		tweak_data.blackmarket.materials.no_material.value = 0
		tweak_data.blackmarket.materials.no_material.weapon_only = true

	end

	-- Inject "no material" material
	local no_material_index = nil
	for k, v in ipairs( data.on_create_data ) do
		if v.id == "no_material" then
			no_material_index = k
			break
		end
	end

	if no_material_index then
		table.remove( data.on_create_data, no_material_index )
	end

	if managers.blackmarket._customizing_weapon and data.category == "materials" then

		local clear_material = deep_clone( data.on_create_data[1] )
		clear_material.id = "no_material"
		clear_material.bitmap_texture_override = "plastic"
		clear_material.free_of_charge = true

		table.insert( data.on_create_data, 1, clear_material )

	end

end)

-- Functions
function GWCBase:AddCustomizablePart( part_id )
	local tbl = clone( GWCBase._default_part_visual_blueprint )
	tbl.id = part_id
	tbl.modifying = false
	table.insert( managers.blackmarket._customizing_weapon_parts, tbl )
end

function GWCBase:CreateCustomizablePartsList( weapon, is_melee )

	-- Clear weapon parts
	managers.blackmarket._customizing_weapon_parts = {}

	if is_melee then
		return
	end

	local blueprint_parts = {}

	-- Add blueprint parts
	for k, v in ipairs( weapon.blueprint ) do

		-- Add blueprint part
		GWCBase:AddCustomizablePart( v )
		blueprint_parts[v] = true

		-- Check if part has adds
		local part_data = tweak_data.weapon.factory.parts[v]
		if part_data and part_data.adds then
			for x, y in pairs( part_data.adds ) do
				GWCBase:AddCustomizablePart( y )
				blueprint_parts[y] = true
			end
		end

	end

	-- Add weapon extra part adds
	local weapon_data = tweak_data.weapon.factory[ weapon.factory_id ]
	if weapon_data and weapon_data.adds then
		for k, v in pairs( weapon_data.adds ) do
			if blueprint_parts[k] then
				for x, y in pairs( v ) do
					GWCBase:AddCustomizablePart( y )
				end
			end
		end
	end

end

function GWCBase:QueueWeaponUpdate( material_id, pattern_id, tint_color_a, tint_color_b, parts_table )

	if not self._update_queue then
		self._update_queue = {}
	end

	local data = {
		["material"] = material_id,
		["pattern"] = pattern_id,
		["color_a"] = tint_color_a,
		["color_b"] = tint_color_b,
		["parts"] = parts_table,
	}
	table.insert( self._update_queue, data )

end

function GWCBase:DequeueUpdate()

	if not self._update_queue then
		log("[Error] Could not dequeue as the update queue does not exist")
		return
	end

	if #self._update_queue > 0 then
		local data = self._update_queue[1]
		GWCBase:UpdateWeapon( data["material"], data["pattern"], data["color_a"], data["color_b"], data["parts"] )
		table.remove( self._update_queue, 1 )
	end

end

function GWCBase:UpdateWeaponPartsWithMaskMod( data )
	GWCBase:UpdateWeaponPartsWithMod( data.category, data.mods.id )
end

function GWCBase:UpdateWeaponPartsWithMod( category, mod_id, parts_table, disable_saving )

	if managers.blackmarket._customizing_weapon and managers.blackmarket._customizing_weapon_data and managers.blackmarket._selected_weapon_parts then

		-- Set selected part
		if managers.blackmarket._selected_weapon_parts[ category ] then
			managers.blackmarket._selected_weapon_parts[ category ] = mod_id
		end

		-- Get parts to modify
		if not parts_table and managers.blackmarket._customizing_weapon_parts then
			parts_table = {}
			for k, v in ipairs( managers.blackmarket._customizing_weapon_parts ) do
				if v.modifying then
					parts_table[v.id] = v
				end
			end
		end

		-- Modify parts
		local weapon_name = managers.blackmarket._customizing_weapon_data.name
		local weapon_category = managers.blackmarket._customizing_weapon_data.category
		if parts_table and (weapon_category == "primaries" or weapon_category == "secondaries") then

			for k, v in pairs( parts_table ) do

				-- Update category mod
				if v[ category ] then
					v[ category ] = mod_id
				end

				-- Update part visuals
				local color_data = tweak_data.blackmarket.colors[ v["colors"] ]
				GWCBase:UpdateWeapon( v["materials"], v["textures"], color_data.colors[1], color_data.colors[2], { [v.id] = true } )

			end

		else

			local wep = managers.blackmarket._global.melee_weapons[weapon_name]
			if wep.visual_blueprint then

				local vis_parts = managers.blackmarket._selected_weapon_parts 
				local color_data = tweak_data.blackmarket.colors[ vis_parts["colors"] ]
				GWCBase:UpdateWeapon( vis_parts["materials"], vis_parts["textures"], color_data.colors[1], color_data.colors[2], { ["melee"] = true } )

			end

		end

		-- Save current weapon customization
		if not disable_saving then
			GWCBase:SaveCurrentWeaponCustomization()
		end

	end

end

function GWCBase:UpdateWeaponUsingOptions()

	local opts = GoonWeacus.Options.GWCBase
	local material = GWCBase._materials_lookup[ opts.Material ]
	local pattern = GWCBase._patterns_lookup[ opts.Pattern ]
	local tint_color_a = Color( opts.Color1R, opts.Color1G, opts.Color1B )
	local tint_color_b = Color( opts.Color2R, opts.Color2G, opts.Color2B )

	if opts.Pattern == 1 then
		if opts.Material == 1 then
			pattern = "no_color_no_material"
		else
			pattern = "no_color_full_material"
		end
	end

	self:UpdateWeapon( material, pattern, tint_color_a, tint_color_b )

end

function GWCBase:UpdateWeapon( material_id, pattern_id, tint_color_a, tint_color_b, parts_table, unit_override )

	if self._requesting then
		log("[Error] Could not update weapon customization, already updating current materials")
		return
	end

	-- Find weapon
	local weapon_base = unit_override or nil

	if not weapon_base then

		if managers.player:local_player() then
			weapon_base = managers.player:local_player():inventory():equipped_unit():base()
		end
		if self._menu_weapon_preview_unit and alive( self._menu_weapon_preview_unit ) then
			weapon_base = self._menu_weapon_preview_unit.base and self._menu_weapon_preview_unit:base() or self._menu_weapon_preview_unit
		end

	end

	if not weapon_base then
		log("[Error] Could not update weapon customization, no weapon unit")
		return
	end

	-- Defaults
	material_id = material_id or "no_material"
	pattern_id = pattern_id or "no_color_no_material"
	if material_id ~= "no_material" and pattern_id == "no_color_no_material" then
		pattern_id = "no_color_full_material"
	end
	if material_id == "no_material" then
		pattern_id = "no_color_no_material"
	end
	tint_color_a = tint_color_a or Color(1, 1, 1)
	tint_color_b = tint_color_b or Color(1, 1, 1)

	-- Callbacks
	local texture_load_result_clbk = callback(self, self, "clbk_texture_loaded")

	self._materials = {}
	self._textures = {}

	-- Find materials
	if type(weapon_base._parts) == "table" then

		for k, v in pairs( weapon_base._parts ) do
			if v.unit and ( (parts_table and parts_table[k]) or not parts_table ) then
				
				local materials = v.unit:get_objects_by_type(Idstring("material"))
				for _, m in ipairs(materials) do
					if m:variable_exists(Idstring("tint_color_a")) then
						table.insert(self._materials, m)
					end
				end

			end
		end

	else

		local materials = weapon_base:get_objects_by_type(Idstring("material"))
		for _, m in ipairs(materials) do
			if m:variable_exists(Idstring("tint_color_a")) then
				table.insert(self._materials, m)
			end
		end

	end

	-- Material
	local old_reflection = self._textures.reflection and self._textures.reflection.name
	local material_amount = 1
	if tweak_data.blackmarket.materials[material_id] then

		local material_data = tweak_data.blackmarket.materials[material_id]
		local reflection = Idstring(material_data.texture)
		if old_reflection ~= reflection then
			self._textures.reflection = {
				name = reflection,
				texture = false,
				ready = false
			}
		end
		material_amount = material_data.material_amount or 1

	end

	-- Pattern
	local old_pattern = self._textures.pattern and self._textures.pattern.name
	if tweak_data.blackmarket.textures[pattern_id] then

		local pattern = Idstring(tweak_data.blackmarket.textures[pattern_id].texture)
		if old_pattern ~= pattern then
			self._textures.pattern = {
				name = pattern,
				texture = false,
				ready = false
			}
		end

	end

	-- Set Textures
	for _, material in ipairs(self._materials) do
		material:set_variable(Idstring("tint_color_a"), tint_color_a)
		material:set_variable(Idstring("tint_color_b"), tint_color_b)
		material:set_variable(Idstring("material_amount"), material_amount)
	end

	-- Load
	self._requesting = true

	for tex_id, texture_data in pairs(self._textures) do
		if not texture_data.ready then
			texture_data.ready = true
			for _, material in ipairs(self._materials) do
				Application:set_material_texture(material, Idstring(tex_id == "pattern" and "material_texture" or "reflection_texture"), texture_data.name, Idstring("normal"), 0)
			end
		end
	end

	self._requesting = nil

end

function GWCBase:clbk_texture_loaded(tex_name)

	for tex_id, texture_data in pairs(self._textures) do
		if not texture_data.ready and tex_name == texture_data.name then
			texture_data.ready = true
			for _, material in ipairs(self._materials) do
				Application:set_material_texture(material, Idstring(tex_id == "pattern" and "material_texture" or "reflection_texture"), tex_name, Idstring("normal"), 0)
			end
		end
	end

end

function GWCBase:SaveCurrentWeaponCustomization()

	if not managers.blackmarket._customizing_weapon or not managers.blackmarket._customizing_weapon_data or not managers.blackmarket._selected_weapon_parts then
		log("[Error] Could not save weapon customization, no customization data")
		return
	end

	-- Get weapon
	local data = managers.blackmarket._customizing_weapon_data
	local weapon_category = data.category
	local weapon_slot = data.slot
	local weapon = GWCBase:GetWeaponTableFromInventory( data )

	if not weapon then
		log("[Error] Could not save weapon customization, no weapon found in category '", weapon_category, "' slot '", weapon_slot, "'")
		return
	end

	-- Setup weapon visual customization save
	if not weapon.visual_blueprint then
		GWCBase:BuildDefaultVisualBlueprint( weapon )
	end

	-- Get modified parts
	local parts = {}
	for k, v in ipairs( managers.blackmarket._customizing_weapon_parts ) do
		if v.modifying then
			parts[v.id] = true
		end
	end
	if weapon_category == "melee_weapons" then
		parts["melee"] = true
	end

	-- Update visual customization
	for k, v in pairs( parts ) do

		local mat = managers.blackmarket._selected_weapon_parts["materials"]
		local tex = managers.blackmarket._selected_weapon_parts["textures"]
		local col = managers.blackmarket._selected_weapon_parts["colors"]

		if not weapon.visual_blueprint[k] then
			weapon.visual_blueprint[k] = clone( GWCBase._default_part_visual_blueprint )
		end

		weapon.visual_blueprint[k]["materials"] = mat
		weapon.visual_blueprint[k]["textures"] = tex
		weapon.visual_blueprint[k]["colors"] = col

	end

	if weapon_category == "primaries" or weapon_category == "secondaries" then
		managers.blackmarket._global.crafted_items[weapon_category][weapon_slot] = weapon
	end
	if weapon_category == "melee_weapons" then
		managers.blackmarket._global.melee_weapons[data.name] = weapon
		self:SaveMeleeWeaponCustomization()
	end

end

function GWCBase:LoadMeleeWeaponCustomization()

	local file = io.open( GWCBase._melee_save_path, "r" )
	if file then

		local data = file:read("*all")
		file:close()

		data = json.decode( data )
		for k, v in pairs( data ) do
			if not managers.blackmarket._global.melee_weapons[k].visual_blueprint then
				managers.blackmarket._global.melee_weapons[k].visual_blueprint = v
			end
		end
		
	end

end

function GWCBase:SaveMeleeWeaponCustomization()

	-- Load all customizations before saving
	self:LoadMeleeWeaponCustomization()

	local file = io.open( GWCBase._melee_save_path, "w+" )
	if file then

		local tbl = {}
		for k, v in pairs( managers.blackmarket._global.melee_weapons ) do
			if v.visual_blueprint then
				tbl[k] = v.visual_blueprint
			end
		end

		file:write( json.encode(tbl) )
		file:close()

	else
		log("[Error] Could not save melee weapon visual customizations...")
	end

end

function GWCBase:LoadCurrentWeaponCustomization( data )

	data = data or managers.blackmarket._customizing_weapon_data

	-- Get weapon
	local weapon_name = data.name 
	local weapon_category = data.category
	local weapon_slot = data.slot
	if not weapon_category or not weapon_slot then
		log("[Error] Could not load weapon customization, could not find category or slot")
		return
	end
	local weapon = GWCBase:GetWeaponTableFromInventory( data )

	if not weapon then
		log("[Error] Could not load weapon customization, no weapon found in category '", weapon_category, "' slot '", weapon_slot, "'")
		return
	end

	-- Attempt to load melee weapon blueprints, if it still doesn't exist then build the default one
	if not weapon.visual_blueprint then

		if weapon_category == "melee_weapons" then

			self:LoadMeleeWeaponCustomization()
			if not weapon.visual_blueprint then
				GWCBase:BuildDefaultVisualBlueprint( weapon )
			end

		else
			GWCBase:BuildDefaultVisualBlueprint( weapon )
		end

	end

	-- Load and apply blueprint
	GWCBase:LoadWeaponCustomizationFromBlueprint( weapon.visual_blueprint )

end

function GWCBase:BuildDefaultVisualBlueprint( weapon )

	if not weapon.visual_blueprint then

		weapon.visual_blueprint = {}
		if weapon.blueprint then
			for k, v in pairs( weapon.blueprint ) do
				weapon.visual_blueprint[v] = clone( GWCBase._default_part_visual_blueprint )
			end
		else
			weapon.visual_blueprint["melee"] = clone( GWCBase._default_part_visual_blueprint )
		end

	end

end

function GWCBase:GetWeaponTableFromInventory( data )
	local category = data.category
	if category == "primaries" or category == "secondaries" then
		return managers.blackmarket._global.crafted_items[category][data.slot]
	end
	if category == "melee_weapons" then
		return managers.blackmarket._global.melee_weapons[data.name]
	end
	return nil
end

function GWCBase:LoadWeaponCustomizationFromBlueprint( blueprint, unit_override )

	if not blueprint then
		log("[Warning] Could not load weapon customization, no visual blueprint specified")
		return
	end

	for k, v in pairs( blueprint ) do

		local material = v["materials"]
		local pattern = v["textures"]
		local blackmarket_color = v["colors"]
		local color = tweak_data.blackmarket.colors[ blackmarket_color ]

		self:UpdateWeapon( material, pattern, color.colors[1], color.colors[2], k and { [k] = true } or nil, unit_override )

	end

end

function GWCBase:LoadEquippedWeaponCustomizations( weapon_base, is_melee )

	local equipped_weapons = {
		[1] = managers.blackmarket:equipped_primary(),
		[2] = managers.blackmarket:equipped_secondary(),
		[3] = managers.blackmarket:equipped_melee_weapon(),
	}

	-- Load primary and secondary weapons
	if weapon_base then

		for k, v in pairs( equipped_weapons ) do
			if weapon_base._factory_id == v.factory_id and v.visual_blueprint then
				GWCBase:LoadWeaponCustomizationFromBlueprint( v.visual_blueprint, weapon_base._unit:base() )
			end
		end

	end

	-- Load melee weapon
	if is_melee then

		self:LoadMeleeWeaponCustomization()

		local melee_weapon = equipped_weapons[3]
		local weapon_blueprint = managers.blackmarket._global.melee_weapons[ melee_weapon ].visual_blueprint
		GWCBase:LoadWeaponCustomizationFromBlueprint( weapon_blueprint, weapon_base )

	end

end

-- Clear Data
function GWCBase:ShowClearDataConfirmation()

	local title = managers.localization:text("WeaponCustomization_ClearDataTitle")
	local message = managers.localization:text("WeaponCustomization_ClearDataMessage")
	local menuOptions = {}
	menuOptions[1] = {
		text = managers.localization:text("WeaponCustomization_ClearDataAccept"),
		callback = callback(self, self, "ClearDataFromSave"),
		is_cancel_button = true
	}
	menuOptions[2] = {
		text = managers.localization:text("WeaponCustomization_ClearDataCancel"),
		is_cancel_button = true
	}
	local menu = QuickMenu:new(title, message, menuOptions, true)

end

function GWCBase:ClearDataFromSave()

	if not managers.blackmarket then
		return
	end

	self:EraseSaveDataPrimary()
	self:EraseSaveDataSecondary()
	self:EraseSaveDataMelee()

end

function GWCBase:EraseSaveDataPrimary()

	log(" Clearing weapon customization data from primary weapons")
	for k, v in pairs( managers.blackmarket._global.crafted_items["primaries"] ) do
		if v.visual_blueprint then
			log("\tClearing visual blueprint: " .. tostring(v.weapon_id))
			v.visual_blueprint = nil
		end
	end

end

function GWCBase:EraseSaveDataSecondary()

	log(" Clearing weapon customization data from secondary weapons")
	for k, v in pairs( managers.blackmarket._global.crafted_items["secondaries"] ) do
		if v.visual_blueprint then
			log("\tClearing visual blueprint: " .. tostring(v.weapon_id))
			v.visual_blueprint = nil
		end
	end

end

function GWCBase:EraseSaveDataMelee()

	log(" Clearing weapon customization data from melee weapons")
	for k, v in pairs( managers.blackmarket._global["melee_weapons"] ) do
		if v.visual_blueprint then
			log("\tClearing visual blueprint: " .. tostring(k))
			v.visual_blueprint = nil
		end
	end

end