
_G.GoonBase.Options = _G.GoonBase.Options or {}
local Options = GoonBase.Options

local mt = getmetatable( Options )
if mt == nil then
	mt = {}
	mt.__func = {}
	mt.__data = {}
	setmetatable( Options, mt )
end

function mt.__index(tbl, key)
	return mt.__data[key] or mt.__func[key]
end

function mt.__newindex(tbl, key, value)
	mt.__data[key] = value
end



local function OptionsSave( self, file_path )

	file_path = file_path or GoonBase.SavePath

	local file = io.open(file_path, "w+")
	if file then

		file:write( json.encode(mt.__data) )
		file:close()

	else
		Print("[Error] Could not save GoonMod options!")
	end

end
rawset( mt.__func, "Save", OptionsSave )

local function OptionsLoad( self, file_path )

	file_path = file_path or GoonBase.SavePath

	local file = io.open( file_path, "r" )
	if file then

		local file_contents = file:read("*all")
		local data = json.decode( file_contents )
		file:close()

		if data then
			mt.__data = data
		end

	else
		Print("[Warning] Could not load file '" .. file_path .. "', no data loaded...")
	end

end
rawset( mt.__func, "Load", OptionsLoad )

Options:Load()
